
package de.ivu.elect.presentation.veranstaltung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeBoundaryCreate;
import de.ivu.elect.business.veranstaltung.entity.Teilnahme;
import de.ivu.elect.business.veranstaltung.entity.TeilnahmeMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractTeilnahmeCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractTeilnahmeCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.TEILNAHME_CREATE)
public abstract class AbstractTeilnahmeCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Teilnahme> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "teilnahmeCreateView";

  public static final String VIEW_ID = "/veranstaltung/teilnahme-create.xhtml";

  public static final String PARENT_VIEW_ID = "/veranstaltung/teilnahme-search.xhtml";

  @Inject
  protected transient TeilnahmeBoundaryCreate create;

  protected Teilnahme entity;

  @Inject
  protected transient TeilnahmeMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Teilnahme());
  }

  

  public Teilnahme getEntity() {
    return entity;
  }

  protected void setEntity(Teilnahme entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.TEILNAHME_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Teilnahme entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Teilnahme entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.TEILNAHME_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
